
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Linux高可用(HA)之MySQL多主一从+Keepalived跨机房集群部署 / iVAN</title>

    <meta name="description" content="Linux高可用(HA)之MySQL多主一从+Keepalived跨机房集群部署 添加host解析.时间同步和ssh互信(注:这里的做ssh互信的时候使用到一个脚本借助expect实现了面交互操作了) [root@DS-CentOS51 ~]# echo &quot;172.16.0.51 mysql-master01 &gt; 172.16.0.60 mysql-master02 &gt; 172.16.0.63 mysql-slave01 &gt; 172.16.0.69 mysql-slave02&quot; &gt;&gt; /etc/hosts [root@DS-C ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Linux高可用(HA)之MySQL多主一从+Keepalived跨机房集群部署</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>添加host解析、时间同步和ssh互信（注：这里的做ssh互信的时候使用到一个脚本借助expect实现了面交互操作了）</p>
<p>[root@DS-CentOS51 ~]# echo "172.16.0.51 mysql-master01<br />
&gt; 172.16.0.60 mysql-master02<br />
&gt; 172.16.0.63 mysql-slave01<br />
&gt; 172.16.0.69 mysql-slave02" &gt;&gt; /etc/hosts<br />
[root@DS-CentOS51 ~]# echo "*/5 * * * * /usr/sbin/ntpdate pool.ntp.org &gt;/dev/null 2&gt;&amp;1" &gt;&gt; /var/spool/cron/root &amp;&amp; ntpdate pool.ntp.org<br />
 8 Jan 04:12:25 ntpdate[64178]: adjust time server 128.138.141.172 offset -0.068359 sec<br />
[root@DS-CentOS51 ~]# ssh-keygen  -t rsa -f ~/.ssh/id_rsa  -P ''<br />
Generating public/private rsa key pair.<br />
Your identification has been saved in /root/.ssh/id_rsa.<br />
Your public key has been saved in /root/.ssh/id_rsa.pub.<br />
The key fingerprint is:<br />
fc:77:72:4d:c0:ed:06:ad:09:8c:b3:d3:d4:95:dc:66 root@DS-CentOS51.dwhd.org<br />
The key's randomart image is:<br />
+--[ RSA 2048]----+<br />
|              . +|<br />
|           o o *E|<br />
|          o + =oo|<br />
|       .   = . * |<br />
|        S o . o +|<br />
|         . .   + |<br />
|          . o o .|<br />
|           . +   |<br />
|                 |<br />
+-----------------+<br />
[root@DS-CentOS51 ~]# cat auto_auth.sh<br />
#!/bin/bash<br />
#########################################################################<br />
# File Name: auto_auth.sh<br />
# Author: LookBack<br />
# Email: admin#dwhd.org<br />
# Version:<br />
# Created Time: 2016年01月08日 星期五 04时18分20秒<br />
#########################################################################<br />
 <br />
password=$2<br />
rundir=`pwd`<br />
 <br />
if ! which expect &gt;/dev/null 2&gt;&amp;1; then yum install -y -q expect;fi<br />
 <br />
expect &lt;&lt; EOF<br />
set timeout 30<br />
spawn ssh-copy-id -i /root/.ssh/id_rsa.pub root@$1<br />
expect {<br />
    "(yes/no)" {send "yes\r"; exp_continue}<br />
    "password:" {send "$password\r"}<br />
}<br />
expect eof<br />
EOF<br />
 <br />
scp ${rundir}/$0 root@$1:~/<br />
[root@DS-CentOS51 ~]# echo mysql-{master0{1,2},slave0{1,2}}| sed 's/ /\n/g'|xargs -i bash auto_auth.sh {} lookback<br />
spawn ssh-copy-id -i /root/.ssh/id_rsa.pub root@mysql-master01<br />
root@mysql-master01's password: <br />
Now try logging into the machine, with "ssh 'root@mysql-master01'", and check in:<br />
 <br />
  .ssh/authorized_keys<br />
 <br />
to make sure we haven't added extra keys that you weren't expecting.<br />
 <br />
auto_auth.sh                                                                                                                                  100%  606     0.6KB/s   00:00    <br />
spawn ssh-copy-id -i /root/.ssh/id_rsa.pub root@mysql-master02<br />
root@mysql-master02's password: <br />
Now try logging into the machine, with "ssh 'root@mysql-master02'", and check in:<br />
 <br />
  .ssh/authorized_keys<br />
 <br />
to make sure we haven't added extra keys that you weren't expecting.<br />
 <br />
auto_auth.sh                                                                                                                                  100%  606     0.6KB/s   00:00    <br />
spawn ssh-copy-id -i /root/.ssh/id_rsa.pub root@mysql-slave01<br />
root@mysql-slave01's password: <br />
Now try logging into the machine, with "ssh 'root@mysql-slave01'", and check in:<br />
 <br />
  .ssh/authorized_keys<br />
 <br />
to make sure we haven't added extra keys that you weren't expecting.<br />
 <br />
auto_auth.sh                                                                                                                                  100%  606     0.6KB/s   00:00    <br />
spawn ssh-copy-id -i /root/.ssh/id_rsa.pub root@mysql-slave02<br />
root@mysql-slave02's password: <br />
Now try logging into the machine, with "ssh 'root@mysql-slave02'", and check in:<br />
 <br />
  .ssh/authorized_keys<br />
 <br />
to make sure we haven't added extra keys that you weren't expecting.<br />
 <br />
auto_auth.sh                                                                                                                                  100%  606     0.6KB/s   00:00    <br />
[root@DS-CentOS51 ~]#</p>
<p>[root@DS-CentOS60 ~]# sed -i '$d' auto_auth.sh<br />
[root@DS-CentOS60 ~]# ssh-keygen  -t rsa -f ~/.ssh/id_rsa  -P ''<br />
Generating public/private rsa key pair.<br />
Your identification has been saved in /root/.ssh/id_rsa.<br />
Your public key has been saved in /root/.ssh/id_rsa.pub.<br />
The key fingerprint is:<br />
8e:05:99:63:7a:5e:f0:69:4f:65:23:84:16:fb:66:2e root@DS-CentOS60.dwhd.org<br />
The key's randomart image is:<br />
+--[ RSA 2048]----+<br />
|        .o.      |<br />
|       ooo       |<br />
|      B.. . +    |<br />
|     o = o + .   |<br />
|    . . S =      |<br />
|     o * *       |<br />
|      o E o      |<br />
|         .       |<br />
|                 |<br />
+-----------------+<br />
[root@DS-CentOS60 ~]# echo mysql-{master0{1,2},slave0{1,2}}| sed 's/ /\n/g'|xargs -i bash auto_auth.sh {} lookback<br />
warning: rpmts_HdrFromFdno: Header V3 RSA/SHA1 Signature, key ID c105b9de: NOKEY<br />
Importing GPG key 0xC105B9DE:<br />
 Userid : CentOS-6 Key (CentOS 6 Official Signing Key) &lt;centos-6-key@centos.org&gt;<br />
 Package: centos-release-6-7.el6.centos.12.3.x86_64 (@CentOS/6.7)<br />
 From   : /etc/pki/rpm-gpg/RPM-GPG-KEY-CentOS-6<br />
spawn ssh-copy-id -i /root/.ssh/id_rsa.pub root@mysql-master01<br />
The authenticity of host 'mysql-master01 (172.16.0.51)' can't be established.<br />
RSA key fingerprint is 8d:44:a4:74:d1:69:08:0c:89:9b:71:ba:25:3c:ff:89.<br />
Are you sure you want to continue connecting (yes/no)? yes<br />
Warning: Permanently added 'mysql-master01,172.16.0.51' (RSA) to the list of known hosts.<br />
root@mysql-master01's password: <br />
Now try logging into the machine, with "ssh 'root@mysql-master01'", and check in:<br />
 <br />
  .ssh/authorized_keys<br />
 <br />
to make sure we haven't added extra keys that you weren't expecting.<br />
 <br />
spawn ssh-copy-id -i /root/.ssh/id_rsa.pub root@mysql-master02<br />
The authenticity of host 'mysql-master02 (172.16.0.60)' can't be established.<br />
RSA key fingerprint is 6a:ef:31:00:88:7f:3d:8d:56:73:e1:2b:d4:f9:61:9c.<br />
Are you sure you want to continue connecting (yes/no)? yes<br />
Warning: Permanently added 'mysql-master02,172.16.0.60' (RSA) to the list of known hosts.<br />
root@mysql-master02's password: <br />
Now try logging into the machine, with "ssh 'root@mysql-master02'", and check in:<br />
 <br />
  .ssh/authorized_keys<br />
 <br />
to make sure we haven't added extra keys that you weren't expecting.<br />
 <br />
spawn ssh-copy-id -i /root/.ssh/id_rsa.pub root@mysql-slave01<br />
The authenticity of host 'mysql-slave01 (172.16.0.63)' can't be established.<br />
RSA key fingerprint is fb:7f:a8:df:a1:70:9b:88:68:d4:e1:20:2f:07:a4:78.<br />
Are you sure you want to continue connecting (yes/no)? yes<br />
Warning: Permanently added 'mysql-slave01,172.16.0.63' (RSA) to the list of known hosts.<br />
root@mysql-slave01's password: <br />
Now try logging into the machine, with "ssh 'root@mysql-slave01'", and check in:<br />
 <br />
  .ssh/authorized_keys<br />
 <br />
to make sure we haven't added extra keys that you weren't expecting.<br />
 <br />
spawn ssh-copy-id -i /root/.ssh/id_rsa.pub root@mysql-slave02<br />
The authenticity of host 'mysql-slave02 (172.16.0.69)' can't be established.<br />
RSA key fingerprint is 1b:5e:e7:cf:51:ed:b7:8d:f7:46:23:57:05:53:43:4b.<br />
Are you sure you want to continue connecting (yes/no)? yes<br />
Warning: Permanently added 'mysql-slave02,172.16.0.69' (RSA) to the list of known hosts.<br />
root@mysql-slave02's password: <br />
Now try logging into the machine, with "ssh 'root@mysql-slave02'", and check in:<br />
 <br />
  .ssh/authorized_keys<br />
 <br />
to make sure we haven't added extra keys that you weren't expecting.<br />
 <br />
[root@DS-CentOS60 ~]#</p>
<p>[root@DS-CentOS63 ~]# sed -i '$d' auto_auth.sh<br />
[root@DS-CentOS63 ~]# ssh-keygen  -t rsa -f ~/.ssh/id_rsa  -P ''<br />
Generating public/private rsa key pair.<br />
Your identification has been saved in /root/.ssh/id_rsa.<br />
Your public key has been saved in /root/.ssh/id_rsa.pub.<br />
The key fingerprint is:<br />
9f:32:dd:3f:48:66:4e:53:5c:ac:c0:70:fa:9e:a7:d1 root@DS-CentOS63.dwhd.org<br />
The key's randomart image is:<br />
+--[ RSA 2048]----+<br />
|          .o.  . |<br />
|           oo   o|<br />
|          .  o o |<br />
|           .  +  |<br />
|        S   ..   |<br />
|         o +*o   |<br />
|        o +*=oE  |<br />
|         o  o=.  |<br />
|            . .. |<br />
+-----------------+<br />
[root@DS-CentOS63 ~]# echo mysql-{master0{1,2},slave0{1,2}}| sed 's/ /\n/g'|xargs -i bash auto_auth.sh {} lookback<br />
warning: rpmts_HdrFromFdno: Header V3 RSA/SHA1 Signature, key ID c105b9de: NOKEY<br />
Importing GPG key 0xC105B9DE:<br />
 Userid : CentOS-6 Key (CentOS 6 Official Signing Key) &lt;centos-6-key@centos.org&gt;<br />
 Package: centos-release-6-7.el6.centos.12.3.x86_64 (@CentOS/6.7)<br />
 From   : /etc/pki/rpm-gpg/RPM-GPG-KEY-CentOS-6<br />
spawn ssh-copy-id -i /root/.ssh/id_rsa.pub root@mysql-master01<br />
The authenticity of host 'mysql-master01 (172.16.0.51)' can't be established.<br />
RSA key fingerprint is 8d:44:a4:74:d1:69:08:0c:89:9b:71:ba:25:3c:ff:89.<br />
Are you sure you want to continue connecting (yes/no)? yes<br />
Warning: Permanently added 'mysql-master01,172.16.0.51' (RSA) to the list of known hosts.<br />
root@mysql-master01's password: <br />
Now try logging into the machine, with "ssh 'root@mysql-master01'", and check in:<br />
 <br />
  .ssh/authorized_keys<br />
 <br />
to make sure we haven't added extra keys that you weren't expecting.<br />
 <br />
spawn ssh-copy-id -i /root/.ssh/id_rsa.pub root@mysql-master02<br />
The authenticity of host 'mysql-master02 (172.16.0.60)' can't be established.<br />
RSA key fingerprint is 6a:ef:31:00:88:7f:3d:8d:56:73:e1:2b:d4:f9:61:9c.<br />
Are you sure you want to continue connecting (yes/no)? yes<br />
Warning: Permanently added 'mysql-master02,172.16.0.60' (RSA) to the list of known hosts.<br />
root@mysql-master02's password: <br />
Now try logging into the machine, with "ssh 'root@mysql-master02'", and check in:<br />
 <br />
  .ssh/authorized_keys<br />
 <br />
to make sure we haven't added extra keys that you weren't expecting.<br />
 <br />
spawn ssh-copy-id -i /root/.ssh/id_rsa.pub root@mysql-slave01<br />
The authenticity of host 'mysql-slave01 (172.16.0.63)' can't be established.<br />
RSA key fingerprint is fb:7f:a8:df:a1:70:9b:88:68:d4:e1:20:2f:07:a4:78.<br />
Are you sure you want to continue connecting (yes/no)? yes<br />
Warning: Permanently added 'mysql-slave01,172.16.0.63' (RSA) to the list of known hosts.<br />
root@mysql-slave01's password: <br />
Now try logging into the machine, with "ssh 'root@mysql-slave01'", and check in:<br />
 <br />
  .ssh/authorized_keys<br />
 <br />
to make sure we haven't added extra keys that you weren't expecting.<br />
 <br />
spawn ssh-copy-id -i /root/.ssh/id_rsa.pub root@mysql-slave02<br />
The authenticity of host 'mysql-slave02 (172.16.0.69)' can't be established.<br />
RSA key fingerprint is 1b:5e:e7:cf:51:ed:b7:8d:f7:46:23:57:05:53:43:4b.<br />
Are you sure you want to continue connecting (yes/no)? yes<br />
Warning: Permanently added 'mysql-slave02,172.16.0.69' (RSA) to the list of known hosts.<br />
root@mysql-slave02's password: <br />
Now try logging into the machine, with "ssh 'root@mysql-slave02'", and check in:<br />
 <br />
  .ssh/authorized_keys<br />
 <br />
to make sure we haven't added extra keys that you weren't expecting.<br />
 <br />
[root@DS-CentOS63 ~]#</p>
<p>[root@DS-CentOS69 ~]# sed -i '$d' auto_auth.sh<br />
[root@DS-CentOS69 ~]# ssh-keygen  -t rsa -f ~/.ssh/id_rsa  -P ''<br />
Generating public/private rsa key pair.<br />
Your identification has been saved in /root/.ssh/id_rsa.<br />
Your public key has been saved in /root/.ssh/id_rsa.pub.<br />
The key fingerprint is:<br />
b6:60:fe:17:40:ae:69:de:48:2a:61:e0:9a:b2:02:5b root@DS-CentOS69.dwhd.org<br />
The key's randomart image is:<br />
+--[ RSA 2048]----+<br />
|                 |<br />
|        .        |<br />
|       o         |<br />
|.       o        |<br />
|..    ooS.       |<br />
|..E  o=o ..      |<br />
|o= . =.o.  .     |<br />
|* . . o.. .      |<br />
|+. .    ..       |<br />
+-----------------+<br />
[root@DS-CentOS69 ~]# echo mysql-{master0{1,2},slave0{1,2}}| sed 's/ /\n/g'|xargs -i bash auto_auth.sh {} lookback<br />
warning: rpmts_HdrFromFdno: Header V3 RSA/SHA1 Signature, key ID c105b9de: NOKEY<br />
Importing GPG key 0xC105B9DE:<br />
 Userid : CentOS-6 Key (CentOS 6 Official Signing Key) &lt;centos-6-key@centos.org&gt;<br />
 Package: centos-release-6-7.el6.centos.12.3.x86_64 (@CentOS/6.7)<br />
 From   : /etc/pki/rpm-gpg/RPM-GPG-KEY-CentOS-6<br />
spawn ssh-copy-id -i /root/.ssh/id_rsa.pub root@mysql-master01<br />
The authenticity of host 'mysql-master01 (172.16.0.51)' can't be established.<br />
RSA key fingerprint is 8d:44:a4:74:d1:69:08:0c:89:9b:71:ba:25:3c:ff:89.<br />
Are you sure you want to continue connecting (yes/no)? yes<br />
Warning: Permanently added 'mysql-master01,172.16.0.51' (RSA) to the list of known hosts.<br />
root@mysql-master01's password: <br />
Now try logging into the machine, with "ssh 'root@mysql-master01'", and check in:<br />
 <br />
  .ssh/authorized_keys<br />
 <br />
to make sure we haven't added extra keys that you weren't expecting.<br />
 <br />
spawn ssh-copy-id -i /root/.ssh/id_rsa.pub root@mysql-master02<br />
The authenticity of host 'mysql-master02 (172.16.0.60)' can't be established.<br />
RSA key fingerprint is 6a:ef:31:00:88:7f:3d:8d:56:73:e1:2b:d4:f9:61:9c.<br />
Are you sure you want to continue connecting (yes/no)? yes<br />
Warning: Permanently added 'mysql-master02,172.16.0.60' (RSA) to the list of known hosts.<br />
root@mysql-master02's password: <br />
Now try logging into the machine, with "ssh 'root@mysql-master02'", and check in:<br />
 <br />
  .ssh/authorized_keys<br />
 <br />
to make sure we haven't added extra keys that you weren't expecting.<br />
 <br />
spawn ssh-copy-id -i /root/.ssh/id_rsa.pub root@mysql-slave01<br />
The authenticity of host 'mysql-slave01 (172.16.0.63)' can't be established.<br />
RSA key fingerprint is fb:7f:a8:df:a1:70:9b:88:68:d4:e1:20:2f:07:a4:78.<br />
Are you sure you want to continue connecting (yes/no)? yes<br />
Warning: Permanently added 'mysql-slave01,172.16.0.63' (RSA) to the list of known hosts.<br />
root@mysql-slave01's password: <br />
Now try logging into the machine, with "ssh 'root@mysql-slave01'", and check in:<br />
 <br />
  .ssh/authorized_keys<br />
 <br />
to make sure we haven't added extra keys that you weren't expecting.<br />
 <br />
spawn ssh-copy-id -i /root/.ssh/id_rsa.pub root@mysql-slave02<br />
The authenticity of host 'mysql-slave02 (172.16.0.69)' can't be established.<br />
RSA key fingerprint is 1b:5e:e7:cf:51:ed:b7:8d:f7:46:23:57:05:53:43:4b.<br />
Are you sure you want to continue connecting (yes/no)? yes<br />
Warning: Permanently added 'mysql-slave02,172.16.0.69' (RSA) to the list of known hosts.<br />
root@mysql-slave02's password: <br />
Now try logging into the machine, with "ssh 'root@mysql-slave02'", and check in:<br />
 <br />
  .ssh/authorized_keys<br />
 <br />
to make sure we haven't added extra keys that you weren't expecting.<br />
 <br />
[root@DS-CentOS69 ~]#</p>
<p>master01上安装MariaDB</p>
<p>[root@DS-CentOS51 ~]# wget -q http://www.dwhd.org/wp-content/uploads/2016/01/install_mysql.sh &amp;&amp; bash install_mysql.sh<br />
#这是一个自动编译安装MySQL5.5 5.6 5.7、MariaDB5.5 10.0 10.1、MariaDB-Galear、Percona5.5 5.6支持主从复制集群的shell脚本</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDExMTIxMTAwNjgwOS5wbmc=.jpg"></p>
<p> </p>
<p>安装结束会显示相关信息<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDExMTIxMTAwODU3LnBuZw==.jpg"></p>
<p> </p>
<p>master02上安装MariaDB(后面节点安装都需要等Master01安装结束才可以继续)</p>
<p> </p>
<table>
<tbody>
<tr>
<td>
<p>1
            </td>
<td>
<p><code>wget -q http:</code><code>//www</code><code>.dwhd.org</code><code>/wp-content/uploads/2016/01/install_mysql</code><code>.sh &amp;&amp; </code><code>bash</code> <code>install_mysql.sh</code></p>
</td>
</tr>
</tbody>
</table>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDExMTIxMTAxMDY0OS5wbmc=.jpg"></p>
<p> </p>
<p>安装结束会显示相关信息<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MDExMTIxMTAxMjQ3Mi5wbmc=.jpg"></p>
<p>sslave01、slave02上安装MariaDB，和Master02上一样，由于这里是自动安装就不多演示了</p>
<p>Master01上安装Keepalived</p>
<p>[root@DS-CentOS51 ~]# wget http://www.keepalived.org/software/keepalived-1.2.19.tar.gz<br />
[root@DS-CentOS51 ~]# scp keepalived-1.2.19.tar.gz root@mysql-master02:~/<br />
keepalived-1.2.19.tar.gz                                                                                                                      100%  322KB 322.4KB/s   00:00    <br />
[root@DS-CentOS51 ~]# tar xf keepalived-1.2.19.tar.gz <br />
[root@DS-CentOS51 ~]# cd keepalived-1.2.19/<br />
[root@DS-CentOS51 ~/keepalived-1.2.19]# ./configure --prefix=/usr/local/keepalived --sysconfdir=/etc --with-kernel-dir=/usr/src/kernels/`uname -r` --enable-sha1<br />
[root@DS-CentOS51 ~/keepalived-1.2.19]# make -j $(awk '/processor/{i++}END{print i}' /proc/cpuinfo) &amp;&amp; make install &amp;&amp; cd ..<br />
[root@DS-CentOS51 ~]# echo "export PATH=/usr/local/keepalived/sbin:\$PATH" &gt; /etc/profile.d/keepalived.sh<br />
[root@DS-CentOS51 ~]# . /etc/profile.d/keepalived.sh<br />
[root@DS-CentOS51 ~]# sed -i "$(awk '/^MANPATH\t/{n=NR}END{print n}' /etc/man.config)a MANPATH\t/usr/local/keepalived/share/man" /etc/man.config<br />
[root@DS-CentOS51 ~]# mv /etc/keepalived/keepalived.conf{,_`date "+%F-%T"`_backup}<br />
[root@DS-CentOS51 ~]# mkdir -p /etc/keepalived/scripts<br />
[root@DS-CentOS51 ~]# ln -sv /usr/local/keepalived/sbin/keepalived /usr/sbin/<br />
[root@DS-CentOS51 ~]# chkconfig keepalived on</p>
<p>Master02上安装Keepalived</p>
<p>[root@DS-CentOS60 ~]# tar xf keepalived-1.2.19.tar.gz<br />
[root@DS-CentOS60 ~]# cd keepalived-1.2.19/<br />
[root@DS-CentOS60 ~/keepalived-1.2.19]# ./configure --prefix=/usr/local/keepalived --sysconfdir=/etc --with-kernel-dir=/usr/src/kernels/`uname -r` --enable-sha1<br />
[root@DS-CentOS60 ~/keepalived-1.2.19]# make -j $(awk '/processor/{i++}END{print i}' /proc/cpuinfo) &amp;&amp; make install &amp;&amp; cd ..<br />
[root@DS-CentOS60 ~]# echo "export PATH=/usr/local/keepalived/sbin:\$PATH" &gt; /etc/profile.d/keepalived.sh<br />
[root@DS-CentOS60 ~]# . /etc/profile.d/keepalived.sh<br />
[root@DS-CentOS60 ~]# sed -i "$(awk '/^MANPATH\t/{n=NR}END{print n}' /etc/man.config)a MANPATH\t/usr/local/keepalived/share/man" /etc/man.config<br />
[root@DS-CentOS60 ~]# mv /etc/keepalived/keepalived.conf{,_`date "+%F-%T"`_backup}<br />
[root@DS-CentOS60 ~]# mkdir -p /etc/keepalived/scripts<br />
[root@DS-CentOS60 ~]# ln -sv /usr/local/keepalived/sbin/keepalived /usr/sbin/<br />
[root@DS-CentOS60 ~]# chkconfig keepalived on</p>
<p>配置Master01上的Keepalived</p>
<p>[root@DS-CentOS51 ~]# cat /etc/keepalived/keepalived.conf<br />
! Configuration File for keepalived<br />
global_defs {<br />
    notification_email {<br />
        admin@dwhd.org<br />
    }<br />
  <br />
    notification_email_from mysql-keepalived@ds.com<br />
    smtp_server 127.0.0.1<br />
    smtp_connect_timeout 30<br />
    router_id MySQL-HA<br />
}<br />
 <br />
vrrp_script check_mysql {<br />
    script "/etc/keepalived/scripts/mysql_check.sh"<br />
    interval 2<br />
}<br />
 <br />
vrrp_sync_group VG1 {<br />
    group {<br />
        VI_1<br />
    }<br />
}<br />
 <br />
vrrp_instance VI_1 {<br />
    state BACKUP<br />
    interface eth0<br />
    virtual_router_id 88<br />
    priority 100  <br />
    advert_int 1<br />
    nopreempt #不进行抢占操作<br />
    authentication {<br />
        auth_type PASS<br />
        auth_pass 1111<br />
    }<br />
    track_script {<br />
        check_mysql<br />
    }<br />
 <br />
    virtual_ipaddress {<br />
        172.16.51.100 label eth0:0<br />
    }<br />
 <br />
    notify_master /etc/keepalived/scripts/master.sh<br />
    notify_backup /etc/keepalived/scripts/backup.sh<br />
    notify_stop /etc/keepalived/scripts/stop.sh<br />
}<br />
[root@DS-CentOS51 ~]#</p>
<p>配置Master02上的Keepalived</p>
<p>[root@DS-CentOS60 ~]# cat /etc/keepalived/keepalived.conf<br />
! Configuration File for keepalived<br />
 <br />
global_defs {<br />
    notification_email {<br />
        admin@dwhd.org<br />
    }<br />
 <br />
    notification_email_from mysql-keepalived@ds.com<br />
    smtp_server 127.0.0.1<br />
    smtp_connect_timeout 30<br />
    router_id MySQL-HA<br />
}<br />
 <br />
vrrp_script check_mysql {<br />
    script "/etc/keepalived/scripts/mysql_check.sh"<br />
    #检查mysqld进程是否存活的脚本，当发现连接不上mysql，自动把keepalived进程干掉，让VIP进行漂移<br />
    interval 2<br />
}<br />
 <br />
vrrp_sync_group VG1 {<br />
    group {<br />
        VI_1<br />
    }<br />
}<br />
 <br />
vrrp_instance VI_1 {<br />
    state BACKUP<br />
    interface eth0<br />
    virtual_router_id 88<br />
    priority 90<br />
    advert_int 1<br />
    authentication {<br />
        auth_type PASS<br />
        auth_pass 1111<br />
    }<br />
    track_script {<br />
        check_mysql<br />
    }<br />
 <br />
    virtual_ipaddress {<br />
        172.16.51.100 label eth0:0<br />
    }<br />
 <br />
    notify_master /etc/keepalived/scripts/master.sh #状态改变为master以后执行的脚本<br />
    notify_backup /etc/keepalived/scripts/backup.sh #状态改变为backup以后执行的脚本<br />
    notify_stop /etc/keepalived/scripts/stop.sh #VRRP停止以后执行的脚本<br />
    #notify_fault /etc/keepalived/scripts/fault.sh #状态改变为fault后执行的脚本。<br />
}<br />
[root@DS-CentOS60 ~]#</p>
<p>配置Master01上的mysql_check.sh</p>
<p>[root@DS-CentOS51 ~]# cat /etc/keepalived/scripts/mysql_check.sh<br />
#!/bin/bash<br />
#########################################################################<br />
# File Name: mysql_check.sh<br />
# Author: LookBack<br />
# Email: admin#dwhd.org<br />
# Version:<br />
# Created Time: 2016年01月08日 星期五 05时12分56秒<br />
#########################################################################<br />
 <br />
username=root<br />
password=ZWE4MDM3NTgwNjc2<br />
bindir="/usr/local/mariadb/bin"<br />
mysql_check() { ${bindir}/mysql -u${username} -p${password} -e "select version();"; }<br />
mysql_pid_check() { ps aux | pgrep mysqld; }<br />
 <br />
while :; do<br />
    [ -n "$(mysql_check)" ] &amp;&amp; [ -n "$(mysql_pid_check)" ] &amp;&amp; exit 0<br />
    [ -n "$(mysql_check)" ] &amp;&amp; exit 0 || {<br />
        [[ "$i" -gt "4" ]] \<br />
            &amp;&amp; break \<br />
            || { let i++ &amp;&amp; sleep 0.3 &amp;&amp; continue; }<br />
    }<br />
done<br />
 <br />
service keepalived stop<br />
[root@DS-CentOS51 ~]#</p>
<p>配置Master02上的mysql_check.sh</p>
<p>[root@DS-CentOS60 ~]# cat /etc/keepalived/scripts/mysql_check.sh<br />
#!/bin/bash<br />
#########################################################################<br />
# File Name: /etc/keepalived/scripts/mysql_check.sh<br />
# Author: LookBack<br />
# Email: admin#dwhd.org<br />
# Version:<br />
# Created Time: 2016年01月08日 星期五 06时30分53秒<br />
#########################################################################<br />
 <br />
username=root<br />
password=ZmE1MmYyZTIxNjU4<br />
bindir="/usr/local/mariadb/bin"<br />
 <br />
mysql_check() { ${bindir}/mysql -u${username} -p${password} -e "select version();"; }<br />
mysql_pid_check() { ps aux | pgrep mysqld; }<br />
 <br />
while :; do<br />
    [ -n "$(mysql_check)" ] &amp;&amp; [ -n "$(mysql_pid_check)" ] &amp;&amp; exit 0<br />
    [ -n "$(mysql_check)" ] &amp;&amp; exit 0 || {<br />
        [[ "$i" -gt "4" ]] \<br />
            &amp;&amp; break \<br />
            || { let i++ &amp;&amp; sleep 0.3 &amp;&amp; continue; }<br />
    }<br />
done<br />
 <br />
service keepalived stop</p>
<p>配置Master01上的master.sh脚本</p>
<p>[root@DS-CentOS51 ~]# cat /etc/keepalived/scripts/master.sh <br />
#!/bin/bash<br />
#########################################################################<br />
# File Name: /etc/keepalived/scripts/master.sh<br />
# Author: LookBack<br />
# Email: admin#dwhd.org<br />
# Version:<br />
# Created Time: 2016年01月08日 星期五 05时33分57秒<br />
#########################################################################<br />
 <br />
username=root<br />
password=ZWE4MDM3NTgwNjc2<br />
bindir="/usr/local/mariadb/bin"<br />
 <br />
Master_Log_File=$(${bindir}/mysql -u${username} -p${password} -e "show slave status\G"| awk '/ Master_Log_File/{print $2}')<br />
Relay_Master_Log_File=$(${bindir}/mysql -u${username} -p${password} -e "show slave status\G" | awk '/Relay_Master_Log_File/{print $2}')<br />
Read_Master_Log_Pos=$(${bindir}/mysql -u${username} -p${password} -e "show slave status\G" | awk '/Read_Master_Log_Pos/{print $2}')<br />
Exec_Master_Log_Pos=$(${bindir}/mysql -u${username} -p${password} -e "show slave status\G" | awk '/Exec_Master_Log_Pos/{print $2}')<br />
 <br />
while :; do<br />
    [ "$Master_Log_File" = "$Relay_Master_Log_File" ] &amp;&amp; [[ "$Read_Master_Log_Pos" -eq "$Exec_Master_Log_Pos" ]] &amp;&amp; { echo "OK" &amp;&amp; break; }<br />
    [ "$Master_Log_File" != "$Relay_Master_Log_File" ] || [[ "$Read_Master_Log_Pos" -ne "$Exec_Master_Log_Pos" ]] &amp;&amp; {<br />
        sleep 10<br />
        [[ "$i" -gt "60" ]] &amp;&amp; break<br />
        let i+=10 &amp;&amp; continue; }<br />
done<br />
 <br />
${bindir}/mysql -u${username} -p${password} -e "stop slave;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global innodb_support_xa=0;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global sync_binlog=0;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global innodb_flush_log_at_trx_commit=0;"<br />
${bindir}/mysql -u${username} -p${password} -e "flush logs;GRANT ALL PRIVILEGES ON *.* TO 'admin'@'%' IDENTIFIED BY '123456';flush privileges;"<br />
${bindir}/mysql -u${username} -p${password} -e "show master status;" &gt; /tmp/master_status_$(date "+%F-%T").txt<br />
[root@DS-CentOS51 ~]#<br />
配置Master02上的master.sh脚本</p>
<p>[root@DS-CentOS60 ~]# cat /etc/keepalived/scripts/master.sh<br />
#!/bin/bash<br />
#########################################################################<br />
# File Name: /etc/keepalived/scripts/master.sh<br />
# Author: LookBack<br />
# Email: admin#dwhd.org<br />
# Version:<br />
# Created Time: 2016年01月08日 星期五 05时33分57秒<br />
#########################################################################<br />
 <br />
username=root<br />
password=ZmE1MmYyZTIxNjU4<br />
bindir="/usr/local/mariadb/bin"<br />
 <br />
Master_Log_File=$(${bindir}/mysql -u${username} -p${password} -e "show slave status\G"| awk '/ Master_Log_File/{print $2}')<br />
Relay_Master_Log_File=$(${bindir}/mysql -u${username} -p${password} -e "show slave status\G" | awk '/Relay_Master_Log_File/{print $2}')<br />
Read_Master_Log_Pos=$(${bindir}/mysql -u${username} -p${password} -e "show slave status\G" | awk '/Read_Master_Log_Pos/{print $2}')<br />
Exec_Master_Log_Pos=$(${bindir}/mysql -u${username} -p${password} -e "show slave status\G" | awk '/Exec_Master_Log_Pos/{print $2}')<br />
 <br />
while :; do<br />
    [ "$Master_Log_File" = "$Relay_Master_Log_File" ] &amp;&amp; [[ "$Read_Master_Log_Pos" -eq "$Exec_Master_Log_Pos" ]] &amp;&amp; { echo "OK" &amp;&amp; break; }<br />
    [ "$Master_Log_File" != "$Relay_Master_Log_File" ] || [[ "$Read_Master_Log_Pos" -ne "$Exec_Master_Log_Pos" ]] &amp;&amp; {<br />
        sleep 10<br />
        [[ "$i" -gt "60" ]] &amp;&amp; break<br />
        let i+=10 &amp;&amp; continue; }<br />
done<br />
 <br />
${bindir}/mysql -u${username} -p${password} -e "stop slave;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global innodb_support_xa=0;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global sync_binlog=0;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global innodb_flush_log_at_trx_commit=0;"<br />
${bindir}/mysql -u${username} -p${password} -e "flush logs;GRANT ALL PRIVILEGES ON *.* TO 'admin'@'%' IDENTIFIED BY '123456';flush privileges;"<br />
${bindir}/mysql -u${username} -p${password} -e "show master status;" &gt; /tmp/master_status_$(date "+%F-%T").txt</p>
<p>配置master01上的baskup.sh脚本</p>
<p>[root@DS-CentOS51 ~]# cat /etc/keepalived/scripts/backup.sh<br />
#!/bin/bash<br />
#########################################################################<br />
# File Name: baskup.sh<br />
# Author: LookBack<br />
# Email: admin#dwhd.org<br />
# Version:<br />
# Created Time: 2016年01月08日 星期五 05时55分05秒<br />
#########################################################################<br />
 <br />
username=root<br />
password=ZWE4MDM3NTgwNjc2<br />
bindir="/usr/local/mariadb/bin"<br />
 <br />
${bindir}/mysql -u${username} -p${password} -e "GRANT ALL PRIVILEGES ON *.* TO 'admin'@'%' IDENTIFIED BY '123456';flush privileges;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global event_scheduler=0;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global innodb_support_xa=0;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global sync_binlog=0;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global innodb_flush_log_at_trx_commit=0;"</p>
<p>配置master02上的backup.sh脚本</p>
<p>[root@DS-CentOS60 ~]# cat /etc/keepalived/scripts/backup.sh<br />
#!/bin/bash<br />
#########################################################################<br />
# File Name: backup.sh<br />
# Author: LookBack<br />
# Email: admin#dwhd.org<br />
# Version:<br />
# Created Time: 2016年01月08日 星期五 06时11分31秒<br />
#########################################################################<br />
 <br />
username=root<br />
password=ZmE1MmYyZTIxNjU4<br />
bindir="/usr/local/mariadb/bin"<br />
 <br />
${bindir}/mysql -u${username} -p${password} -e "GRANT ALL PRIVILEGES ON *.* TO 'admin'@'%' IDENTIFIED BY '123456';flush privileges;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global event_scheduler=0;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global innodb_support_xa=0;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global sync_binlog=0;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global innodb_flush_log_at_trx_commit=0;"</p>
<p>配置master01上的stop.sh脚本</p>
<p>[root@DS-CentOS51 ~]# cat /etc/keepalived/scripts/stop.sh<br />
#!/bin/bash<br />
#########################################################################<br />
# File Name: /etc/keepalived/scripts/stop.sh<br />
# Author: LookBack<br />
# Email: admin#dwhd.org<br />
# Version:<br />
# Created Time: 2016年01月08日 星期五 06时13分20秒<br />
#########################################################################<br />
 <br />
username=root<br />
password=ZWE4MDM3NTgwNjc2<br />
bindir="/usr/local/mariadb/bin"<br />
 <br />
${bindir}/mysql -u${username} -p${password} -e "GRANT ALL PRIVILEGES ON *.* TO 'admin'@'%' IDENTIFIED BY '1q2w3e4r';flush privileges;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global innodb_support_xa=1;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global sync_binlog=1;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global innodb_flush_log_at_trx_commit=1;"<br />
 <br />
M_File1=$(${bindir}/mysql -u${username} -p${password} -e "show master status\G" | awk '/File/{print $2}')<br />
M_Position1=$(${bindir}/mysql -u${username} -p${password} -e "show master status\G" | awk '/Position/{print $2}')<br />
sleep 1<br />
M_File2=$(${bindir}/mysql -u${username} -p${password} -e "show master status\G" | awk '/File/{print $2}')<br />
M_Position2=$(${bindir}/mysql -u${username} -p${password} -e "show master status\G" | awk '/Position/{print $2}')<br />
 <br />
while :; do<br />
    [ "$M_File1" = "$M_File1" ] &amp;&amp; [[ "$M_Position1" -eq "$M_Position2" ]] &amp;&amp; { echo "ok" &amp;&amp; break; }<br />
    [ "$M_File1" != "$M_File1" ] || [[ "$M_Position1" -ne "$M_Position2" ]] &amp;&amp; {<br />
        sleep 10<br />
        [[ "$i" -gt "60" ]] &amp;&amp; break<br />
        let i+=10 &amp;&amp; continue; }<br />
done</p>
<p>配置master02上的stop.sh脚本</p>
<p>[root@DS-CentOS60 ~]# cat /etc/keepalived/scripts/stop.sh<br />
#!/bin/bash<br />
#########################################################################<br />
# File Name: stop.sh<br />
# Author: LookBack<br />
# Email: admin#dwhd.org<br />
# Version:<br />
# Created Time: 2016年01月08日 星期五 06时25分55秒<br />
#########################################################################<br />
 <br />
username=root<br />
password=ZmE1MmYyZTIxNjU4<br />
bindir="/usr/local/mariadb/bin"<br />
 <br />
${bindir}/mysql -u${username} -p${password} -e "GRANT ALL PRIVILEGES ON *.* TO 'admin'@'%' IDENTIFIED BY '1q2w3e4r';flush privileges;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global innodb_support_xa=1;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global sync_binlog=1;"<br />
${bindir}/mysql -u${username} -p${password} -e "set global innodb_flush_log_at_trx_commit=1;"<br />
 <br />
M_File1=$(${bindir}/mysql -u${username} -p${password} -e "show master status\G" | awk '/File/{print $2}')<br />
M_Position1=$(${bindir}/mysql -u${username} -p${password} -e "show master status\G" | awk '/Position/{print $2}')<br />
sleep 1<br />
M_File2=$(${bindir}/mysql -u${username} -p${password} -e "show master status\G" | awk '/File/{print $2}')<br />
M_Position2=$(${bindir}/mysql -u${username} -p${password} -e "show master status\G" | awk '/Position/{print $2}')<br />
 <br />
while :; do<br />
    [ "$M_File1" = "$M_File1" ] &amp;&amp; [[ "$M_Position1" -eq "$M_Position2" ]] &amp;&amp; { echo "ok" &amp;&amp; break; }<br />
    [ "$M_File1" != "$M_File1" ] || [[ "$M_Position1" -ne "$M_Position2" ]] &amp;&amp; {<br />
        sleep 10<br />
        [[ "$i" -gt "60" ]] &amp;&amp; break<br />
        let i+=10 &amp;&amp; continue; }<br />
done</p>
<p>设置master01 02上Keepalived脚本有执行权限</p>
<p>[root@DS-CentOS51 ~]# chmod +x /etc/keepalived/scripts/*.sh<br />
[root@DS-CentOS51 ~]# ssh root@mysql-master02 "chmod +x /etc/keepalived/scripts/*.sh &amp;&amp; ls -l /etc/keepalived/scripts/"<br />
总用量 16<br />
-rwxr-xr-x 1 root root  833 1月   8 06:12 backup.sh<br />
-rwxr-xr-x 1 root root 1826 1月   8 06:28 master.sh<br />
-rwxr-xr-x 1 root root  764 1月   8 06:31 mysql_check.sh<br />
-rwxr-xr-x 1 root root 1467 1月   8 06:26 stop.sh<br />
[root@DS-CentOS51 ~]#</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 17:41:37</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e9%9b%86%e7%be%a4/" title="集群">集群</a>, <a href="https://www.iamivan.net/tag/null/" title="null">null</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Linux高可用(HA)之MySQL多主一从+Keepalived跨机房集群部署的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7xyZz.html" rel="bookmark">Linux高可用&lpar;HA&rpar;之Heartbeat&plus;Nginx&plus;MySQL&plus;NFS实现WEB&plus;SQL服务高可用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				环境说明: node1:ZhongH100.wxjr.com.cn 172.16.6.100 node2:ZhongH101.wxjr.com.cn 172.16.6.101 NFS存储:ZhongH102.wxjr.com.cn 172.16.6.102 VIP:172.16.7.200 node1和node2的主机名.SSH互通 操作系统:都是CentOS 6.6 x86_64 (自己配置好yum源.epel源.关闭SELinux.关闭防火墙) 注意:是[root@ZhongH100 ~]还			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGAyP3M.html" rel="bookmark">对于一个偶尔高并发的活动页面（涉及db操作，db为mysql，集群部署），你怎么做</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 对于一个偶尔高并发的活动页面(涉及db操作,db为mysql,集群部署),你怎么做 对于一个偶尔高并发的活动页面(涉及db操作,db为mysql,集群部署),你怎么做 解决方案 高并发的话,可以通过据库集群.库表散列.缓存等技术: 偶尔的话,建议选择mongoDB非关系数据库.你是开发的话我想应该懂mongoDB吧. 对了景安新推出快云mongoDB,你可以去免费公测试试. 解决方案二: 高并发,一般使用负载均衡解决前端访问问题,用进程管理器解决业务逻辑调度问题,db如果是你的业务瓶颈			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQWKap.html" rel="bookmark">全是干货---Linux 高可用（HA）集群基本概念详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://www.linuxidc.com/Linux/2013-08/88522.htm 高可用集群的衡量标准    HA(High Available), 高可用性群集是通过系统的可靠性(reliability)和可维护性(maintainability)来度量的.工程上,通常用平均无故障时间(MTTF)来度量系统的可靠性,用平均维修时间(MTTR)来度量系统的可维护性.于是可用性被定义为:HA=MTTF/(MTTF+MTTR)*100%   具体HA衡量标准: 99% 一年宕机时间不超			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7BL0z.html" rel="bookmark">Corosync&plus;Pacemaker&plus;DRBD&plus;Mysql高可用HA配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://koumm.blog.51cto.com/703525/1769116 操作系统: CentOS 6.6 x64,本文采用rpm方式安装corosync+pacemaker+drbd,采用二进制版本安装mysql-5.6.29.本文是在Corosync+Pacemaker+DRBD+NFS高可用实例配置基础上进行配置修改,然后进行测试的安装过程. 一.双机配置 1. app1,a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boRVXEz.html" rel="bookmark">5项优化4种高可用方案，MySQL常用架构调优这样做！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				选择Percona Server.MariaDB还是MYSQL   1.Mysql三种存储引擎   MySQL提供了两种存储引擎:MyISAM和 InnoDB,MySQL4和5使用默认的MyISAM存储引擎.从MYSQL5.5开始,MySQL已将默认存储引擎从MyISAM更改为InnoDB.   MyISAM没有提供事务支持,而InnoDB提供了事务支持.   XtraDB是InnoDB存储引擎的增强版本,被设计用来更好的使用更新计算机硬件系统的性能,同时还包含有一些在高性能环境下的新特性.  			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo6jLvz.html" rel="bookmark">具备负载均衡功能MySQL服务器集群部署及实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 引言 MySQL是一个高速度.高性能.多线程.开放源代码,建立在客户/服务器(Client/Server)结构上的关系型数据库管理系统(RDBMS).它始于1979年,最初是Michael Widenius为瑞典TcX公司创建的UNIREG数据库系统,当时的UNIREG没有SQL(Structured Query Language结构化查询语言)接口,限制了它的应用.1996年5月,Widenius开发出了MySQL的最初版本,开始在Internet上公开发行.MySQL的开发人员从一开始			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqOERYz.html" rel="bookmark">具有负载均衡功能的MySQL服务器集群部署及实现&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在实际生产环境中,部署和实现具有一定负载均衡功能的 MySQL服务器集群,对于提高用户数据库应用系统的性能.速度和稳定性具有明显的作用.本文简要介绍了在 FreeBSD 7.0-Release系统上部署实现MySQL服务器集群的方案,并对可能出现的问题提供了相应的解决方法.1. 引言MySQL是一个高速度.高性能.多线程.开放源代码,建立在客户/服务器(Client /Server)结构上的关系型数据库管理系统(RDBMS).它始于1979年,最初是Michael Widenius为瑞典TcX公			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZwE6qb.html" rel="bookmark">在linux下，怎么创建多个tomcat&comma;也就是说创建一个tomcat集群，分散一个tomcat的压力</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 要求就是题目说的,不知道我说明白了没,就是建立一个tomcat集群,分散一个tomcat压力.请高手指点一下!! 解决方案 解决方案二:使用apache,用google搜索一下apahcetomcat群集,很多帖子说明怎么做的.解决方案三:具体忘了,大概就是server.xml中修改配置,windows和linux没有多大的不同			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr3PN4p.html" rel="bookmark">基于资源编排在专有网络环境下快速部署高可用的Dubbox服务（ZooKeeper版）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文将介绍在专有网络VPC(Virtual Private Cloud)下,基于资源编排服务,快速部署高可用的Dubbox服务的过程.Dubbox服务采用的注册中心是ZooKeeper集群.做这件事情的意义在于:节约部署Dubbox的时间,降低部署Dubbox过程中出错的风险. ROS阿里云资源编排(Resource Orchestration)是一种简单易用的云计算资源管理和自动化运维服务.用户通过模板描述多个云计算资源的依赖关系.配置等,并自动完成所有资源的创建和配置,以达到自动化部署.运维			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzwlomb.html" rel="bookmark" class="title">在Eclipse中构建备忘单</a>
					<div>
						Eclipse提供了一种用于显示迷你型指南的内置机制,称为备忘单(cheat sheet).备忘单可以快速而有效地指导您如何在Eclipse中执行包含多个步骤的过程,它显示在工作台的边角处,您可以容易 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDJDWM.html" rel="bookmark" class="title">站长如何赚钱 资深经验分享</a>
					<div>
						经验|站长|赚钱 有句话说得好,穿别人的鞋,走自己的路,让别人去找吧. 还有句话说得好,不想做将军的士兵不是好士兵,不想赚钱的站长不是好站长. 最近刚建了个学生站长群,两天的时间就已经100人了,而大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9QNKM.html" rel="bookmark" class="title">WordPress数据库冗余？快用优化插件WP Clean Up</a>
					<div>
						  WordPress是一种使用PHP语言和MySQL数据库开发的开源Blog系统,它有很强大的扩展功能.但是随着内容的增多,使用WordPress时的一个弊端就日益体现出来了:数据库的冗余. Wor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNxO4z.html" rel="bookmark" class="title">PHP生成静态页面的方法</a>
					<div>
						在PHP网站开发中为了网站推广和SEO等需要,需要对网站进行全站或局部静态化处理,PHP生成静态HTML页面有多种方法,比如利用PHP模板.缓存等实现页面静态化,今天就以PHP实例教程形式讨论PHP生 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlwJDb.html" rel="bookmark" class="title">设计理论参考&colon;用户研究和竞品分析方法</a>
					<div>
						人类学是关于人的研究:社会人类学(social anthropology)是研究人类社会的学科.社会人类学还可以理解成&quot;文化翻译&quot;(the translation culture) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMq4gkb.html" rel="bookmark" class="title">Ad Rotator组件使用例子</a>
					<div>
						转载: ASP精品屋 钱丰云from: http://asp.superexpert.com/code/code.asp?cid=88Tha Ad Rotator component enables  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKw05b.html" rel="bookmark" class="title">外链建设切勿急躁 构建与发布更要步步&OpenCurlyDoubleQuote;经&rdquo;心</a>
					<div>
						我觉得我没有必要再去啰嗦外链建设的重要性,大家心里肯定和明镜似的,都知道外链建设就是网站腾飞的基础,但是真谈到外链建设的深层次问题,我相信大家(也包括我)肯定有认识不足的地方,作为网站发展的左膀右臂, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62qZyM.html" rel="bookmark" class="title">C语言的多态实现</a>
					<div>
						相信很多人都看过设计模式方面的书,大家有什么体会呢?Bridge,Proxy,Factory这些设计模式都是基于抽象类的.使用抽象对象是这里的一个核心. 其实我觉得框架化编程的一个核心问题是抽象,用抽 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1R1Y8p.html" rel="bookmark" class="title">在Word 2007表格中输入内容</a>
					<div>
						在Word2007中插入表格后,可以在需要输入内容的单元格中单击鼠标左键, 使其处于编辑状态,然后即可输入内容.在改变输入内容的单元格时,既可以通 过单击鼠标左键也可以按下Tab键,如图2009010 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlN7Ob.html" rel="bookmark" class="title">ASP&period;NET中实现获取调用方法名</a>
					<div>
						  需要添加相应的命名空间: 复制代码 代码如下: using System; using System.Diagnostics; using System.Reflection; 如果仅是获取当前方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62V1yM.html" rel="bookmark" class="title">使用CSS3制作饼状旋转载入效果的实例</a>
					<div>
						今天,要实现一个长任务等待提示效果. 然后设计师就把做好的gif效果图给我,就是下面这个: 按照大众做法,我应该是把图片直接按图索骥,调调布局,然后早早回家抱老婆. 但是,我这个人,天生不安分守己.想 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBONLb.html" rel="bookmark" class="title">Dreamweaver用表格制作线框教程</a>
					<div>
						在DreamWeaver里,表格被更多的应用在布局网页,定位内容上.其实除了这些&quot;大功能&quot;的运用,通过各种变通的方法,表格还能实现很多在设计中一般难以达到的效果,下面将要给大家展示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Zgw9b.html" rel="bookmark" class="title">js添加select下默认的option的value和text的方法</a>
					<div>
						 &lt;pre name=&quot;code&quot; class=&quot;java&quot;&gt; jsp 中的下拉框标签: &lt;s:select name=&quot;sjx&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6WJZM.html" rel="bookmark" class="title">计算数据库中各个表的数据量和每行记录所占用空间</a>
					<div>
						CREATE TABLE #tablespaceinfo ( nameinfo VARCHAR(500) , rowsinfo BIGINT , reserved VARCHAR(20) , data ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrX4ZM.html" rel="bookmark" class="title">亚马逊Prime提价</a>
					<div>
						北京时间3月14日早间消息,亚马逊周四宣布,该公司计划从下周起将其颇受欢迎的Prime服务的包年费用提高20美元,至99美元.业界人士认为,此举可能打消潜在用户付费使用这种服务的念头,导致Prime服 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NBeYM.html" rel="bookmark" class="title">《流量的秘密&colon; Google Analytics网站分析与优化技巧&lpar;第3版&rpar;》一2&period;3 了解网站分析数据的准确性</a>
					<div>
						2.3 了解网站分析数据的准确性 流量的秘密: Google Analytics网站分析与优化技巧(第3版) 网站分析对于衡量网站的表现相当重要.但是,只有在避免一些常见的数据收集错误(特别是对不同来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWYXOp.html" rel="bookmark" class="title">信号灯错误会导致连锁错误</a>
					<div>
						&quot;7·23&quot;动车事故初步分析原因公布后,有 网友质疑,高铁上的列车都是高速运行,不可能靠司机目视红绿灯来决定是否停车. 对此,昨晚,北京交通大学教授赵坚说,动车的行车安全主要靠自动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5gmBM.html" rel="bookmark" class="title">Android通讯录数据库操作</a>
					<div>
						1. ContactsProvider2.java (实现了ContentProvider) 2. ContactsContract.java 所有的联系人Uri,与联系人相关数据库字段均在此定义.这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRnk2p.html" rel="bookmark" class="title">难以避免的泄漏事故：怎么解？</a>
					<div>
						世界各地的企业都在担忧网络安全威胁问题,特别是每天看到大量窃取信息和知识产权的网络入侵报告,以及新型漏洞利用方法的兴起,包括勒索软件.高级持续性威胁和内部威胁等. 让问题更严重的是当前快速变化的运营环 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEdv3M.html" rel="bookmark" class="title">《循序渐进学Spark》一1&period;2　在Linux集群上部署Spark</a>
					<div>
						1.2 在Linux集群上部署Spark Spark安装部署比较简单,用户可以登录其官方网站(http://spark.apache.org/downloads.html)下载Spark最新版本或历史 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDERaz.html" rel="bookmark" class="title">Version Control with Git （Udacity）优达学城笔记--L1：What is Version Control</a>
					<div>
						What is Version Control version control: control version Version Cotrol Systems: Git, Subversion, Me ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YkaPz.html" rel="bookmark" class="title">在jsp中把隐藏域的值传到java后台</a>
					<div>
						问题描述 &lt;input type+&quot;hidden&quot; id=&quot;tagEweb&quot; name=&quot;tagEweb&quot; value=&quot;f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boddnjM.html" rel="bookmark" class="title">CEA开源性能测试工具N2D2 人工智能芯片竞赛开始了</a>
					<div>
						ZD至顶网服务器频道 12月25日 新闻消息: 深度学习在2016年持续成为业界热门话题.而在即将来临的2017年里,专家们称人工智能社区对高性能.高效的深层神经网络&quot;推理&quot;引擎的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7lXkz.html" rel="bookmark" class="title">如何才能调出最佳的状态</a>
					<div>
						朋友们,有谁认真思考过自己现在过得怎么样?有谁能够与别人进行客观对比?有谁愿意一辈子都碌碌无为?又有谁会深刻地反省自己?有谁愿意为获得成功而有超乎常人的努力和付出? 1.同样是人,为什么有人不断创造成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdy9B1z.html" rel="bookmark" class="title">【英雄帖】阿里云创业大学导师招募进行时</a>
					<div>
						文:林云 编辑:小鲜 阿里云创业大学自2015年启动以来,集合阿里巴巴集团.阿里云以及知名合作伙伴的导师资源.通过线上视频课程及线下沙龙分享为创业者提供创业指导.截止目前为止,阿里云创业大学已经在全国 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYKy8b.html" rel="bookmark" class="title">任天堂Wii U主机销售惨败</a>
					<div>
						[http://www.aliyun.com/zixun/aggregation/6149.html&quot;&gt;TechWeb报道]1月18日消息,任天堂周五宣布,其Wii U主机的销售已经失 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKq91Ap.html" rel="bookmark" class="title">js操作checkbox遇到的问题解决&lowbar;javascript技巧</a>
					<div>
						遇到操作checkbox的问题全选 复制代码 代码如下: $(&quot;input[type='checkbox']&quot;).each(function(){    this.checked= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOY9wb.html" rel="bookmark" class="title">返回页面顶部top按钮通过锚点实现&lpar;自写&rpar;&lowbar;javascript技巧</a>
					<div>
						实现了我的小跳槽以后,从8月7号入职了现在的这家公司,我好像是加入了救火队的行列,还没有开始开发新的模块,只是一直在实现已经上线模块中的新需求,有时候也真想问问,某些用户的脑子是不是进水了,提出来的需 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8NDe3b.html" rel="bookmark" class="title">大概-故障诊断方面的问题，求程序</a>
					<div>
						问题描述 故障诊断方面的问题,求程序 对电流信号所对应的Par对电流信号所对应的Park矢量模平方进行离散小波变换,画出中心频率在0~10hz之间的一个或多个小波变换结果曲线?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5erRz.html" rel="bookmark" class="title">帮忙看下这个分页为什么生成的数据是乱的呢？</a>
					<div>
						问题描述 &lt;%@LANGUAGE=&quot;VBscript&quot;CODEPAGE=65001%&gt;&lt;%OptionExplicitResponse.Charset=&quot ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.039 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
